#pragma once

#pragma pack(1)
////////////////////////////////////////////////////////////////////////////
// NB6 VċL
struct NB6HEAD
{
	WORD year;
	char season;
	char name[13];
	char scenario;
	char difficulty;
};

//ỹASYz
//0cƌĂ΂ꂽlBLɑB
//MGgƍNقA֓O⏼ivGB
//IȃoX̗ǂ^CvA
//com̏ꍇ͂΂葝₵A܂푈ȂB
//1cҏɑBēcƂ`iƂ암B
//2c퓬ɋBȂǁB
//3c퓬B쎁^BDH
//4c]ᓙAVEl̕lnBDH
//5cEҕAveEn@`ȂǁBDB
//6cڗȂURB\^CvH
//7cIWiPBi͕sB
//255c_PBi͕sB

struct NB6GENERAL
{
	WORD prev;
	WORD next;
	WORD _undef2;		//must 0xFFFF
	byte maxgov;		//
	byte maxbat;		//
	byte maxint;		//q
	WORD expgov;		//n
	WORD expbat;		//n
	WORD expint;		//qn
	char charm;			//
	char ambition;		//]
	char loyal;			//
	WORD merits;		//M
	byte blood;			// 0xFF͖
	WORD attach;		//喼
	WORD gundan;		//Rc
	WORD castle;		//
	WORD rise;			// 0xFFFF
	byte soldier;		//
	byte training;		//P
	byte solloyal;		//mC
	byte form;			//
	byte work;			//d
	byte spouse;		//
	byte birth;			//N - 1454(VċLN)
	WORD parent;		//eNO
	byte algo;			//vl
	byte duty:4;		//`
	byte affinity:4;	//
						//00aa bbcc a-qK b-K c-K
	byte aptitudegov:2;	//c-K (2=A,1=B,0=C)
	byte aptitudebat:2;	//b-K (2=A,1=B,0=C)
	byte aptitudeint:2;	//a-qK (2=A,1=B,0=C)
	byte undef_5:2;		//
	byte tech_ikkatsu:1;	//Z\Eꊅ
	byte tech_ansatsu:1;	//Z\EÎE
	byte tech_ryusyutsu:1;	//Z\Eo
	byte tech_sendou:1;		//Z\E
	byte tech_ryugen:1;		//Z\E
	byte tech_benzetsu:1;	//Z\Eِ
	byte tech_yakiuchi:1;	//Z\Eē
	byte tech_chohatsu:1;	//Z\E
	byte job;			//E 00 0x10 E 20 l 30  40 m

	byte aptitudeasi:3; //yK				(0=E,1=D,2=C,3=B,4=A,5=S)
	byte aptitudekib:3; //RnK				(0=E,1=D,2=C,3=B,4=A,5=S)
	byte _aptitudegun_hi:2; //SCKʃrbg(0=E,1=D,2=C,3=B,4=A,5=S) WrbgE̋ڂɂcЂ`
	byte _aptitudegun_lo:1; //SCKʃrbg(0=E,1=D,2=C,3=B,4=A,5=S) WrbgE̋ڂɂcЂ`
	byte aptitudesui:3; //RK				(0=E,1=D,2=C,3=B,4=A,5=S)

	byte biggun:1;		//C
	byte horsegun:1;	//RnSC
	byte steelship:1;	//SbD
	byte _undef:1;		//0
	byte life:3;		//
	byte brave:3;		//E
	byte _independence_hi:2;//Ɨʃrbg WrbgE̋ڂɂcЂ`
	byte _independence_lo:1;//Ɨʃrbg WrbgE̋ڂɂcЂ`
	byte tone:3;		//
	byte bEnd:1;		//s
	byte bRise:1;		//
	byte grudge:1;		//⍦
	byte flag:1;		//
};

struct NB6GENERALNAME
{
	char familyname[7];
	char fastname[7];
	WORD number;		//H
	byte State:4;		//0喼,1R,2,3B,4Ql,5P,6ҋ@,7S
	byte position:4;	//g
	byte sex;			// 0-j 1-
};

struct NB6CASTLE
{
	WORD prev;		//Rc郊Xg Ȍ
	WORD next;		//Rc郊Xg ̏
	WORD master;
	WORD ronin;
	char name[9];
	WORD attach;	//
	byte build;		//s
	WORD grain;		//΍
	byte town;		//
	WORD population;//l
	byte loyal;		//
	WORD soldier;	//
	byte quality;	// 0-2
	byte _undef0:2;	//{ 
	byte bSmith:1;	//b
	byte bHorse:1;	//nYn
	byte _undef3:1;	//0
	byte bPort:1;	//`
	byte blPort:1;	//ۍ`
	byte _undef4:1;	//
	byte bSilver:1;	//R
	byte bGold:1;	//R
	byte _undef5:2;	//
	byte bRevolt:1;	//Ꝅ
	byte _undef6:3;	//
	byte bgback:2;	//G\́Awi̎ (0=R) (1=) (2=C) (3=)
	byte title:6;	//́B
	byte _undef7:3;	//
	byte bLarge:1;	//
	byte _undef8:4;	//
};


struct NB6CASTLEMAX
{
    byte name;		//n於(nԍ)
	byte _undef1;	//must 0
	byte maxgrain;	//Ő΍/10
	byte maxtown;	//ŏ
	byte _x_unknown;	//ZX̂
	byte _y_unknown;	//ZŶ
	byte x;			//ZXW    w͂RႢ炢łאڂĂ邱ƂBQȉ͊mɗאڂĂB
	byte y;			//ZYW	   x͂QȉȂאڂĂB
};

struct NB6GUNDAN
{
	WORD prev;
	WORD next;
	WORD residence;
	WORD leader;
	WORD attach;	//
	byte act;
	WORD money;		//
	WORD rise;		//
	WORD horse;		//n
	WORD gun;		//SC
	byte _undef;	//must 0?
	byte number:4;	//1-8
	byte position:4;//E
};

struct NB6DAIMYO
{
    WORD attach;	//喼
	WORD gundan;	//Rc
	WORD castle;	//
	WORD retire;	//BXg擪
	byte symbol;	//Ɩ
    byte tyotei;	//
	byte hostile;	//GΑ喼
	byte friendship;//FD喼
	byte _undef0;	//
	byte merchant;	// l
	byte bPropagate:1;//z
	byte _undef1:3;	 // must 0 (z̎c)
	byte bHyotei:1;	//]
	byte _undef2:3;	// must 0 (]̎c)
	byte position;	//E
	byte _undef3[6];
};

struct NB6KAHOU
{
	char name[13];
	byte type;
	byte face;
	WORD attach;	//L
	byte param:4;	//㏸l
	byte _undef0:4;	//0
	byte _undef1:6;	//
	byte bMitojo:1;	//o
	byte bLost:1;	//
};


/*
			[(18*250)]

			0-12	O
*/
struct NB6KANI
{
	char name[13];	//O
	byte rank;		//ʂ̃N(ʂƂ𐔒lɂ ԍ̂0AႢقǐl傫)
	WORD attach;	//L
	byte param;		//㏸l
	byte _undef0;	//
};
	

#pragma pack()
